/***************************************************************************
 *   Copyright (C) 2007 by Julien Keller   *
 *   j.keller@imperial.ac.uk   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "sort.h"
#include "GeneratePoints.h"
#include "Group.h"
#define Complex  std::complex<double>
#define PI  3.14159265358979323846
#define E   2.71828182845904523536
//const double  ERR=1.0e-13;
#define MAXSTP 100.
   //should be a double
//Maximum steps for Durand Kerner algo
#define pow2(x) (x*x)
#define pow3(x) (x*x*x)
#define pow4(x) pow2(x*x)
#define pow5(x) (x*pow4(x))
#define pow6(x) pow2(pow3(x))
#define pow8(x) pow2(pow4(x))


/*
double Norm(Point &y)   //norm of a point in Proj coords
{ return y.comp.norm_euclid();}

Point PointNormalize(Point &x)
{
  Point P(N);
  P=x.scalar_(((Complex) 1./Norm(x)));
  return P;
}
*/
double getMass(const Point &x,const Complex Psi)
{
  Complex y[Degree];
  VVector<int> Projective_space2;
  Projective_space2.resize(N-1,1);
  
  Point xnew=normalisation_proj_space(x);
//  cout << " x-new "<< xnew;
  int i=ChooseMax(xnew);
  int j,l=0;
  for (int k=0;k<N;k++){
    if(k!=i){
       Projective_space2[l]=Projective_space[k];
       l++;
    }
  }
  AffineCoord(x, y, i);
  Complex Mass;
  MMatrix<Complex> FS(Degree,Degree), O(Dimension,Dimension);
  
  
  VVector<Complex> df, d4;
  d4.resize(Dimension,1);
  df = ProjChooseY4(y,Psi,Projective_space2);

  //MMatrixProjFSmetric(y,FS,Projective_space2);
  MMatrixFSmetric(y,FS);
//  FS = FSmetric(y);
  //cout << df <<endl;
  for (i=0; i<Dimension; i++) d4[i] = -df[i]/df[Degree-1];
  //cout << d4;
  for (i=0; i<Dimension; i++)
    for (j=i; j<Dimension; j++)
    {
        O[i][j] = FS[i][j] + FS[Dimension][j]*d4[i] + FS[i][Dimension]* conj(d4[j]) + FS[Dimension][Dimension]*d4[i]* conj(d4[j]) ;
      if(i!=j) O[j][i] = conj(O[i][j]);
    }
  
  Mass=determinant(O);
  ///show(df);
  ///show(Projective_space2);
//  cout<<"\n results " << abs(df[Dimension]) <<"  "<< Mass<< "  "<<determinant(FS)<< 1.0/abs( Mass * abs(df[Dimension]) );
 // getchar();  
   
// 
   
   
  return sqrt(E)*pow(abs((std::complex<double>(N, 0))*Psi ),2.)/abs( Mass * pow(abs(df[Dimension]),2.) );
///1.0/abs( Mass * abs(df[Dimension]) );
}
/*
double getMassMin(const Point &x, int &i,const Complex Psi)
{
  Complex y[Degree];
  int j;
  i = ChooseMax(x);
  AffineCoord(x, y, i);
  Complex Mass;
  Matrix FS(Degree,Degree), O(Dimension,Dimension);
  Vector df(Degree), d4(Dimension);
  df = ChooseY4(y,Psi);
  FS = FSmetric(y);
  for (i=0; i<Dimension; i++) d4(i) = -df(i)/df(Dimension);
  for (i=0; i<Dimension; i++)
    for (j=i; j<Dimension; j++)
    {
      O(i,j) = FS(i,j) + FS(Dimension,j)*d4(i) + (FS(i,Dimension) + FS(Dimension,Dimension)*d4(i)) * conj(d4(j));
      if(i!=j) O(j,i) = conj(O(i,j));
    }
  switch(Dimension)
  {
  case 1:
    Mass=O(0,0);
    break;
  case 2:
    Mass=O(0,0)*O(1,1) - O(0,1)*O(1,0);
    break;
  case 3:
    Mass=O(1,1)*O(2,2)*O(0,0)-O(1,1)*O(2,0)*O(0,2)+O(2,1)*O(0,2)*O(1,0)
         -O(2,1)*O(1,2)*O(0,0)+O(0,1)*O(1,2)*O(2,0)-O(0,1)*O(2,2)*O(1,0);
    break;
  }
  return 1.0/abs( Mass * norm(df(Dimension)) );
}
*/

// adds 2 points
Point add(const Point &P1,const Point &P2)
{
  Point Pnew(max(P1.length(),P2.length()));
  Pnew.mass=0;
  for(int i=0;i<Pnew.length();i++)
  {
    Pnew.comp[i]=P1.comp[i]+P2.comp[i];
  }
  return(Pnew);
}

/*
Point add(Point &x,Point &y)
{ Point sum(N); sum.comp=x.comp+y.comp; return sum;}
 
Point times(const Point &x, const Complex &t)
{ Point sum(N); sum.comp=t*x.comp; return sum;}
*/
Complex auxPol(Complex &t, Point &x1, Point &x2,const Complex Psi)
{  return f(add(x1,x2.scalar_(t)),Psi)/f(x2,Psi);}
/*
void testingRootCloseness(const Vector &Roots)
{
  for(int i=0; i<N; i++)
    for(int j=i+1; j<N; j++) if( abs(Roots(i)-Roots(j)) < 1e-2 ) cout<<"RootCloseness? ";
}
*/
/*
int DKstepold(Point &x1,Point &x2, Vector &Roots, const double &ERR, const Complex Psi,MMatrix<double> &cases){
  Vector tmp(N);
  Complex denom;
  double error=1;
  int i, count=0;

  while(error>ERR)
  {
    
    tmp = Roots;
    for(i=0; i<N; i++)
    {
      denom = 1.0;
      for(int j=0; j<N; j++) if(j!=i) denom=denom*(tmp[i]-tmp[j]);
      Roots(i) -= auxPol(tmp[i], x1,x2,Psi)/denom;
    }
    error=0; for(i=0; i<N; i++) error += abs(auxPol(Roots(i), x1,x2,Psi));
    if (count>MAXSTP){
      cases[0][0]; 
      return 0;
    }
    count++;
  }
  //testingRootCloseness(Roots);
  cases[1][0]++;
  return 1;
 
  
}
*/

//Durand Kerner algorithm to solve f(x)=0
int DKstep(Point &x1,Point &x2, VVector<Complex>
&Roots, const double &ERR, const Complex Psi,const int degree_polynomial,MMatrix<double> &cases)
{
  VVector<Complex> tmp;
  tmp.resize(degree_polynomial,1);
  Complex denom;
  double error=1;
  double error_previous;
  int i, count=0;
  double maxstep=MAXSTP*degree_polynomial;
  // int badsense=1; //means that the error is decreasing
  
  Complex denom1=f(x2,Psi);
  while(error>ERR)
  {

    tmp = Roots;
    
    for(i=0; i<degree_polynomial; i++)
    {
      denom = denom1;
      for(int j=0; j<degree_polynomial; j++) if(j!=i) denom*=(tmp[i]-tmp[j]);
      Roots[i] -=  f(add(x1,x2.scalar_(tmp[i])),Psi)/denom;
          //(f(x2,Psi)*denom);
      //auxPol(tmp[i], x1,x2,Psi)/denom;
      //              ;
      //
    }
    error_previous=error;
    error=0; for(i=0; i<degree_polynomial; i++) error +=abs(f(add(x1,x2.scalar_(Roots[i])),Psi));
    
    if(count>=3)
    {
      if(isnan(error) ||error_previous+pow(MAXSTP,degree_polynomial)*ERR<error 
         || error>pow(MAXSTP,2*degree_polynomial))
         ///error_previous-ERR<error || isnan(error)) 
         ///|| error>pow(MAXSTP,2*degree_polynomial))
        
      {
        cases[0][0]++;
        return 0;
      }
       
      else
      {
        if(error/ERR<pow(MAXSTP,degree_polynomial/2.)) //I don't know how relevant is that condition
        {
          maxstep=min((MAXSTP*degree_polynomial/2.),maxstep+1);
        }
      }
    }
    
    //abs(auxPol(Roots(i), x1,x2,Psi));
    //  cout<< "\n error - " <<error;
    if (count>maxstep)
    {
      /*
     cout<< "\n"<< error <<endl;
      for(i=0; i<degree_polynomial; i++) cout << "  " <<abs(f(add(x1,x2.scalar_(Roots(i))),Psi));
      cout << "\n";
      for(i=0; i<degree_polynomial; i++) cout << "  " <<Roots(i);
        //        cout <<tmp ;*/
      //x1.print();
      //x2.print();

      //getchar();
      cases[2][0]++;
      return 0;
    }
    count++;
  }
 // cout<< "\n error - " <<error;
  //testingRootCloseness(Roots);
  cases[1][0]++;
  return 1;
}

/*
int DurandKernerold(Point &x1,Point &x2, u::vector<Point> &X, const double &ERR, const Complex Psi, Vector &Roots,MMatrix<double> &cases)
{
  cases[3][0]++;
  int i, k=DKstep(x1,x2, Roots, ERR,Psi,N,cases);
  if (k==1)
    for(i=0; i<N; i++) {
    X(i).resize(x1.length());
    X(i) = add(x1, x2.scalar_(Roots(i)));
//    X(i).comp = (x1.comp +Roots(i)*x2.comp);
//    X(i).comp=X(i).comp/X(i).comp.norm_euclid();
    X(i) = normalisation_f(X(i));  
    }
    else
    {
      cases[3][0]++;
      k = DKstep(x2,x1, Roots, ERR,Psi,N,cases);
      if (k==1)
        for(i=0; i<N; i++){

        X(i).resize(x1.length());
        X(i) = add(x2, x1.scalar_(Roots(i)));
        //X(i).comp = (x2.comp + Roots(i)*x1.comp); X(i).comp=X(i).comp/X(i).comp.norm_euclid();
        X(i) = normalisation_f(X(i));  
        } 
        else return 0;
    }
    return 1;
}
*/
int DurandKerner(Point &x1,Point &x2, VVector<Point> &X, const double &ERR, const Complex Psi, VVector<Complex>
&Roots,const int degree_polynomial,MMatrix<double> &cases)
{
  cases[3][0]++;
  int i, k=DKstep(x1,x2, Roots, ERR,Psi,degree_polynomial,cases);
  if (k==1)
    for(i=0; i<degree_polynomial; i++)
    {
     // X(i).resize(x1.length());//TODO useful ?
      X[i] = add(x1,x2.scalar_(Roots[i]));
      X[i] = normalisation_f(X[i]);
     }
  else
  {
    cases[3][0]++;
    k = DKstep(x2,x1, Roots, ERR,Psi,degree_polynomial,cases);
    if (k==1)
      for(i=0; i<degree_polynomial; i++)
      {
        X[i] = add(x2, x1.scalar_(Roots[i]));
        X[i] = normalisation_f(X[i]);
      }
    else return 0;
  }
  return 1;
}

/// Define a random number generator and initialize it with a reproducible seed. seed is unsigned
///RNG rng(37u);
///typedef boost::uniform_on_sphere<double,vector<double> > PtsOnSphere;
///typedef boost::variate_generator<RNG&, PtsOnSphere> gen_type;
///gen_type uni(rng, PtsOnSphere((2*(N-1)+1)+1));//extra +1 since they call S^n the S^{n-1}
/*
gen_type uni2(const int d){
    return gen_type uni(rng, PtsOnSphere((2*d+1)+1));
}*/

void getaPoint2(Point &P, const int dim,MMatrix<double> &coords)
{
//  MMatrix<double> coords(2*dim,1);
  int i;
  double norm;
  do{
  for(i =0; i<2*dim; i++)
   {
       coords[i][0]  = Random::Uniform<float>(-1, 1);
       norm = coords.norm2( );
   }
   }
   while(norm>1);
   //getchar();
   coords*=(1./norm);
   for( i=0; i<dim; i++) {P.comp[i]=coords[2*i][0]+_Complex_I*coords[2*i+1][0];}
}
/*
void getaPoint(Point &P,const int dim)      // generates one pt on P^D
{
  vector<double> v;
  v= uni();
   //  gen_type uni2(rng, PtsOnSphere((2*(dim-1)+1)+1));
  //v = uni2();      // gives a pt on the sphere S^N
  for(int i=0; i<dim; i++) {P.comp[i]=v[2*i]+_Complex_I*v[2*i+1];}
}
*/
double rnd() {return double(rand())/RAND_MAX;}

// Creates a point
void PtGenerator(vector<Point> *X, VVector<Complex>
*Roots, const int NP,const Complex Psi,const double ERR,const int degree_polynomial,MMatrix<double> &cases)
{
  Random::Randomize(1234);
  Point v1(N),v2(N), t1(N);
  MMatrix<double> coords(2*N,1);
 
  int i,k;
  VVector<Point> Xt;
  Xt.resize(degree_polynomial,1);
  double phi;
  Complex w;
  int cc;
  double mass_max,mass_min,mass_total=0;//one coould also affect for i==0
  while((*X).size()<NP)       // generate NP points
  {
  //  cout<<"\n point number "<< (*X).size();
    getaPoint2(v1,N,coords);  
    getaPoint2(v2,N,coords);
    k = DurandKerner(v1,v2,Xt,ERR,Psi,*Roots,degree_polynomial,cases);
    
    cc=0;
    while (k==0)
    {
      phi = 2*PI * rnd();
      w = rnd() * exp(_Complex_I*phi);
      t1 = v1;
      //t2 = v2;
      //v1 = add(t1, times(v2, w));
      v1=add(v1,v2.scalar_(w));
      v2=add(v2,t1.scalar_(w));
      //v2 = add(t2, times(v1, w));
      // PointNormalize(v1); TODO not clear why it is used
      // PointNormalize(v2);
      //for(i=0; i<N; i++) (*Roots)[i] *= rnd();
      k = DurandKerner(v1,v2,Xt,ERR,Psi,*Roots,degree_polynomial,cases);
      cc++;
    }
    //   if(cc>5) cout<< (*X).size()<<" "<< cc++<<" " <<'\n';
    //gives the number of points already computed
    
    
    for(i=0; i<degree_polynomial; i++)
    {
       // cout<< "\n f(X)="<< f(Xt(i),0.1)<< " "<<Psi;
        if(not( Xt[i].comp.norm_euclid()==0 || isnan(Xt[i].comp.norm_euclid())))
        {    
/*        if((*X).size()<degree_polynomial){
            cout <<"-------------------------";
            Xt(i).print();
            }
*/      
         Xt[i].mass = getMass(Xt[i],Psi);
        
         if((*X).size()==0){
           mass_max=Xt[i].mass; 
           mass_min=Xt[i].mass;
         }

         if(Xt[i].mass>mass_max){
             mass_max=Xt[i].mass;
         }
         if(Xt[i].mass<mass_min){
             mass_min=Xt[i].mass;
         }
         mass_total+=Xt[i].mass;
         (*X).push_back(Xt[i]);
      }
    }
    //cc=Newton(Xt(i)); if(cc==0) cout<< "Failed \n";
    /*
    
    */
  }
  //double min=(*X)[0].mass, max=(*X)[0].mass, t;
  //for (i=0; i<NP; i++) {t=(*X)[i].mass; if(t>max) max=t; if(t<min) min=t;}
  cout<<"\nRatio Max/min (for volume form): "<< mass_max/mass_min <<
      "   Mass of the manifold = \033[31m"<< mass_total/NP <<"\033[0m "<< endl;
 /// show(cases);  //TODO should be an option
  //getchar();
  //should be around 15-25, ie not too large to have accuracy.
}

void permuteX(const vector<int> &Perm, Point &X)
{           // applies a permuation Perm to a vector v
  Point Y(X.length());
  for(int i=0; i<X.length(); i++) Y.comp[i] = X.comp[Perm[i]];
  Y.mass = X.mass;
  X=Y;
}

void sort(Point &x)     // finds the largest abs value coordinate
{                       //  and go to that affine patch on P^D
  int i,j;
  Complex a;

  for(j=1; j<x.length(); j++)
  {
    a = x.comp[j];
    i = j;
    while(i>0 && abs(x.comp[i-1])>abs(a) )
    {x.comp[i]= x.comp[i-1]; i--;}
    x.comp[i] = a;
  }
}

void normalizeX1(vector<Point> &X, int NP, ofstream &file)
{
  double t=0, s=0;
  int i;
  for(i=0; i<NP; i++) t += X[i].mass;
  for(i=0; i<NP; i++) X[i].mass /= t;
  for(i=0; i<NP; i++) s += pow( X[i].mass-1.0/NP, 2);
  s = sqrt(s/(NP-1)); cout <<"Sigma:" << s << '\n';
  for(i=0; i<NP; i++) write(X[i],file);
}

void normalizeX(vector<Point> &X, int NP, ofstream &file)
{
  double t=0, s=0;
  int i, J;
  for(i=0; i<NP; i++) t += X[i].mass;
  t /= NP;
  for(i=0; i<NP; i++) s += pow( X[i].mass-t, 2);
  s = sqrt(s/(NP-1));
  cout <<"Sigma:" << s/t << '\n';
  vector<vector<int> > S_n=S_N<vector<int> >(N);
  Complex tx;

  for(i=0; i<NP/120; i++)
    for(J=0; J<120; J++)
    {
      //      J = rand()%120;
      //    sort(X[i]);
      permuteX(S_n[J], X[i]);
      write(X[i],file);
    }
}

// procedure to generate the points on the manifold
void generate_points(const int NP,const int NI,const Complex Psi,const int precision_generate_points,const int degree_polynomial,const double ERR)
{
  ofstream file_data_output;
  file_data_output.open("PointsData");
  cout.precision(5); file_data_output.precision(precision_generate_points);
  int i;
  MMatrix<double> cases(4,1);

  vector<Point> X,X1; // NP pts on the CY

  VVector<Complex> Roots, Roots1;
  Roots.resize(degree_polynomial,1);
  Roots1.resize(degree_polynomial,1); 
for(i=0; i<degree_polynomial; i++) Roots[i]= pow(0.4+0.9*_Complex_I,i); Roots1 = Roots; // initial roots
  //0.4+0.9*I
///  using namespace boost;

  for(int j=0; j<max(NI/2,1); j++)
  {

   /* cout << "Number of Iterations =" <<  j+1 ;
    printf("     || (Cores = %d) \n",NI);*/
    PtGenerator(&X,&Roots,NP,Psi,ERR,degree_polynomial,cases);
    //TODO Do this procedure using multi-processors functions
//    thread T( bind(&PtGenerator, &X ,&Roots, NP,Psi,ERR,degree_polynomial) );
//    PtGenerator( &X1,&Roots1,NP,Psi,ERR,degree_polynomial)  ;
//    T.join();
    file_data_output << NP <<" = Points computed." << endl;
    cout <<"\033[34m** Sorting points \033[0m ";
    quicksort( X, NP); //sort the point wrt to the mass, the lowest mass last
    cout << "\n--> Points sorted." <<endl;

    for(i=0; i<NP; i++) write(X[i],file_data_output);
//    for(i=0; i<NP; i++) write(X1[i],file_data_output);
    //normalizeX(X,Number_Points,file); normalizeX(X1,Number_Points,file); // writes and evaluates eta
  }
  file_data_output.close();
  /* double    mass=0;
   for(i=0; i<NP; i++) {
	
        mass+=X[i].mass;
     }
    cout<< "Mass of the manifold=" << mass/NP<<endl;
*/
}


