/***************************************************************************
 *   Copyright (C) 2007 by Julien Keller   *
 *   j.keller@imperial.ac.uk   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef GENERATEPOINT_H
#define GENERATEPOINT_H
#include "random-singleton.h"

//#include <boost/random/variate_generator.hpp>
//#include <boost/random/mersenne_twister.hpp>
//#include <boost/random/uniform_on_sphere.hpp>    //Boost libraries //
//#include <boost/thread/thread.hpp>
//#include <boost/bind.hpp>
//typedef boost::mt19937 RNG;   // random number generator


#include "GenericFunctions.h"
#include "Equation.h"

void normalizeX(vector<Point> &X, int NP, ofstream &file);
void PtGenerator(vector<Point> *X, VVector<Complex> *Roots,const int NP,const Complex Psi,const double ERR);
double getMass(const Point &x,const Complex Psi);
double getMassMin(const Point &x, int &i,const Complex Psi);
Point PointNormalize(const Point &x);
void generate_points(const int NP,const int NI,const Complex Psi,const int precision_generate_points,const int degree_polynomial,const double ERR);
int DKstep(const Point &x1, const Point &x2, VVector<Complex> &Roots, const double &ERR, const Complex Psi,const int degree_polynomial);
Complex auxPol(Complex &t,  Point &x1, Point &x2,const Complex Psi);


#endif 

