/***************************************************************************
 *   Copyright (C) 2007 by Julien Keller   *
 *   j.keller@imperial.ac.uk   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
///Will take care only of findind symmetries and thus blocks for computing
///the metric. Was before a part of group.cpp

#ifndef SYMMETRIES
#define SYMMETRIES

#include <algorithm>
#include <vector>

#include "Group.h"
#include "GenericFunctions.h"

//#include <boost/numeric/ublas/vector_proxy.hpp>
//#include <boost/numeric/ublas/triangular.hpp>
//#include <boost/numeric/ublas/lu.hpp>

vector<int> theNumbers(int k, int B);
vector<vector<int> > homogenousPoly(int n, int k);
vector<vector<int> > trimSections(int n, int k);
vector<vector<int> > getThePairs(vector<vector<int> > &Sec, int n, vector<int> &Blocks, int NS);
vector<vector<int> > looseSome(int &ns, vector<vector<int> > L, int k, VVector<int> Bs, VVector<int> Bl, VVector<int> &BsO, VVector<int> &BlO);


template<class T> vector<T> makeGensOfG(int n);
template<class T> int oneAction(const T &a, const T &b, const T &g);
template<class T> int compare(const T &v1, const T &v2);
template<class T> int Slim(vector<T>  &v);
template<class T> vector<T> AllPairs(T &S, int N);



#endif

