/***************************************************************************
 *   Copyright (C) 2007 by Julien Keller                                   *
 *   jkeller@imperial.ac.uk                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef WP_PROCEDURE
#define WP_PROCEDURE
#include "Curvatures.h"
#include "GenericFunctions.h"
#include "methods.h"


Complex DerivY4(const Point &X,const Complex Psi);
double WPmetric(MMatrix<Complex> Gnew,Data_in & Data,const int Number_Points,Complex Psi,const int K,ResultsStore &additResults,double put_to_memory);

void CsqrtF( MMatrix<Complex> &Csqrt );
void LinvS(Point &X, MMatrix<Complex> &Linv,Data_in & Data,ResultsStore &additResults,const int NS,const int K,VVector<Complex> &S);
double gpsipsiF(vector<Point> &X, MMatrix<Complex> &Linv, MMatrix<Complex> &Ginv, MMatrix<Complex> &projA,Data_in & Data,ResultsStore &additResults,const int NS,const int Number_Points,const int K, const Complex Psi,double put_to_memory);

void LinvdeltaS(const Point &X, MMatrix<Complex> &Linv, VVector<Complex> &deltaS,Data_in & Data, ResultsStore &additResults, const Complex Psi,const int NS,double put_to_memory);


MMatrix<Complex> projAF(vector<Point> &X, MMatrix<Complex> &Linv, MMatrix<Complex> &Ginv, const int Number_Points,const int K,Data_in & Data,ResultsStore &additResults,const Complex Psi,double put_to_memory);
//VVector<Complex> LinvdeltaS(const Point &X, MMatrix<Complex> &Linv, VVector<Complex> &deltaS, ResultsStore &additResults, const Complex Psi,const int NS);
//MMatrix<Complex> projAF(vector<Point> &X, MMatrix<Complex> &Linv, MMatrix<Complex> &Ginv, const int Number_Points,const int K,Data_in & Data,ResultsStore &additResults,const Complex Psi);
#endif



