/***************************************************************************
 *   Copyright (C) 2007 by Julien Keller   *
 *   j.keller@imperial.ac.uk   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

 

#include "calabiyau.h"





/////////////////////////////////////////////////////////////////////////////////
int main()
{

    
  //initialisations//

  //  init_Projective_space(Projective_space);

  /////////////////
  //TIMERS SET UP
  /////////////////
  struct timeval *Tpbegin, *Tpend;
  struct timezone *Tzp;
  Tpbegin = ( struct timeval* ) malloc ( sizeof ( struct timeval ) );
  Tpend = ( struct timeval* ) malloc ( sizeof ( struct timeval ) );
  Tzp = 0;

  ////////////////////////////////
  //read parameter file 'param'
  ////////////////////////////////
  ifstream param ( "param" ) ;
  if ( !param.is_open() )
  {
    cout << " * No input parameter file found \n Using standard values" << endl;
  }
  else
  {
    cout << "\n--> Reading input parameters from 'param' file\n";
    param >> Number_Points;
    skipline ( param );
    param >> Number_Iterations;
    Number_Iterations=NUMBER_CPUS*Number_Iterations;
    skipline ( param );
    param >> Psi_start;
    skipline ( param );
    param >> radius_Psi_end;
    skipline ( param );
    param >> angle_Psi_end;
    skipline ( param );
    param >> radius_Psi_step;
    skipline ( param );
    param >> angle_Psi_step;
    skipline ( param );

    param >> ERR;
    skipline ( param );
    param >> precision_generate_points;
    skipline ( param );
    param >> precision_output;
    skipline ( param );
    param >> K;
    skipline ( param );
    param >> Einstein;
    skipline ( param );
    param >> Refined;
    skipline ( param );
    param >> read_points_from_file;
    skipline ( param );
    param >> print_ratio;
    skipline ( param );
    param >> ratio_refined;
    skipline ( param );
    param >> print_scalar;
    skipline ( param );
    param >> print_coeff;
    skipline ( param );
    param >> refined_nb_iterations;
    skipline ( param) ;
    param >> put_to_memory;
    /*TODO Dimension + degree
          param >> Dimension;
          skipline(param);
          param >> Degree;
          skipline(param);
          N=Degree+1;

    */
    param.close() ;
  }
     
  /////////////////////////////////////
  ///This part generates the metric ///
  /////////////////////////////////////

  cout << "\n\033[34m ** Generating the metric\033[0m" ;
  int NS, BS;  //number of sections, number of blocks


  //find the number of points
  ifstream file;
  file.open( "PointsData" );
  if ( read_points_from_file==0)
  {
    //  skipline ( file );
  }
  if ( read_points_from_file==1 )
  {
    file >> Number_Points;
    //  skipline ( file );
  }
  file.close();

  cout.precision ( precision_output ); file.precision ( precision_generate_points+1 );

  // do the section business
  vector<vector<int> > Sec = trimSections (degree_polynomial_f()-1, K ); // the sections s_\alpha
  vector<int> Block;
  NS=Sec.size();
  vector<vector<int> > PairsL;
  if(no_use_symmetry==1){
       vector< vector < vector<int> > > v=AllPairs(Sec,degree_polynomial_f());
       for(int i=0;i<NS;i++)
       {
            Block.push_back(1);
       }
       PairsL = Sec; 
  }
  else{
  cout << "\n ** Symetries found. \n--> We have found the following identical elements :\n";
  PairsL = getThePairs ( Sec,degree_polynomial_f(),Block,NS );
  }
  //this is an array of array that contains couples (i,j) that represent the same value in the big hermitian matrice representing the FS metric.  Size around 1000 * 50 *(int,int).
  cout << "\n--> Sections that we will compute :\n";
  //i.e the terms of the form (x_1^a_1 * x_2^a_2 *  ..* x_dimension^{a_dimension}..) with \sum a_i=k.
  //print ( Sec );
  print(PairsL);
  //getchar();
  // printMaple(Sec,file1);

  //print(PairsL);  //TODO Improve in order to get a nice output

  BS=Block.size(); // number of sections and non-trivial pairs (i,j)
  cout << "\n--> Number of sections+non-trivial pairs that will be computed : BS = " << BS << endl;
  VVector<int> Bt;
  Bt.resize(BS,1);
  VVector<int> Bl0;
  Bl0.resize(BS,1);
  VVector<int> Bs0;
  Bs0.resize(BS,1);

  int i=0, j; // i=0 crucial!
  for ( j=0; j<BS; j++ ) {Bt[j] = i; i += Block[j];}
  VVector<int> Bl;
  Bl=Bt;
  for ( j=0; j<BS; j++ )  Bt [j] = Block[j];
  VVector<int> Bs;
  Bs=Bt;
  int NSo=NS; // end of diagonal blocks, changed in next line
  ///vector<vector<int> > Pairs=looseSome ( NSo, PairsL, 124, Bs,Bl, BsO,Bl0 );
  vector<vector<int> > Pairs=looseSome ( NSo, PairsL, NS, Bs,Bl, Bs0,Bl0 );
  // to simplify the computations we remove some pairs : useless for the moment
  cout<< "\n Bs and BsO: \n" ;
  show( transposeV(Bs) );show ( transposeV(Bs0) );
  cout<< "\n Bl and BlO: \n" ;
  show ( transposeV(Bl) );show( transposeV(Bl0) );
  //cout<< "\n\033[32m [***] Pairs after loosing some: \033[0m\n";
  //print ( Pairs ); //actually we don't do anything for the moment
  //TODO make a choice of the right sections to remove
  //getchar();


  //u::zero_vector<double> Zero ( BS );
  vector<Point> X(Number_Points);
//  X.resize ( Number_Points,1 );  // contains all the points on the CY . size = (dimension+1/2) * Complex * Number_Points.
  MMatrix<Complex> vI_new2 ( BS,1 );

  //This is experimental : one would like to store coefficients that don't become too lage
  MMatrix<Complex> vI_new_horner ( BS,1 );///contains 1 and a_{i}/a_{i+1} of step j
  MMatrix<Complex> vI_new_old_ratio ( BS,1 );///contains a_{i}^(j)/a_{i}^(j+1) of step j,j+1
  //

  vI_new_old_ratio.fillWith ( 1 );
  vI_new2= initialize2 ( Pairs, Bl0 ); //initalisation of the metric

  vI_new_horner=coeffsToHorner ( vI_new2 );
  Data_in Data;  //declaration of the object Data



  Complex Psi;
  double Psi_r; //the radius of the point Psi
  double Psi_a; //the angle  of the point Psi
  int start=0;
  int counter=0;
  for(Psi_r=radius_Psi_step; Psi_r <= radius_Psi_end; Psi_r+=radius_Psi_step)
  {
    for(Psi_a=0; Psi_a <= angle_Psi_end; Psi_a+=angle_Psi_step)
    {
         counter++;  //gives number of iterations 
    }
  }
  MMatrix<Complex> ResultsWPmetric;
  for(Psi_r=radius_Psi_step; Psi_r <= radius_Psi_end; Psi_r+=radius_Psi_step)
  {
    for(Psi_a=0; Psi_a <= angle_Psi_end; Psi_a+=angle_Psi_step)
    {
      Psi=Psi_start+Psi_r*exp(_Complex_I*Psi_a);
      
// + (Psi_r)*exp(_Complex_I*Psi_a);
      cout << "\n--> Number_Sections=\033[31m" << NS << '\t'<< "\033[0m Polarization power: K=\033[31m" << K <<
      "\n\033[0m Dimension of the manifold=\033[31m" << Dimension << '\t' << "\033[0m Number of Points=\033[31m" << Number_Points << "\033[0m\n" << " Complex parameter=" << Psi << '\n'  ;
      if ( Einstein==1 )
      {
        cout << "\n\033[32m [***] Using Ricci flow approximation method \033[0m" ;
      }
      cout <<"\n-----------------------------" << endl <<
      "\033[34m** Starting the iterations **\033[0m\n"
      <<"-----------------------------"<< endl;


      /////////////////////////////////////
      ///THIS PART GENERATES THE POINTS ///
      /////////////////////////////////////
      if ( read_points_from_file==0 )
      {
        gettimeofday ( Tpbegin, Tzp );
        int degree_polynomial=degree_polynomial_f();
        generate_points(Number_Points,NUMBER_CPUS,Psi,precision_generate_points,degree_polynomial,ERR );
        gettimeofday ( Tpend, Tzp );

        print_time ( "\n\033[31m--> Points of the manifold found. \033[0m \n--> Time for finding points on the manifold 0m",Tpend,Tpbegin );
      }


      //in this loop we read the points and their masses
      gettimeofday ( Tpbegin, Tzp );
      file.open("PointsData");
      for ( i=0; i<Number_Points; i++ )
      {
        skipline ( file );
        X [ i ] = read<Point> ( file );
        //one needs a pointer to know where we are in the file
        //see http://www.cplusplus.com/doc/tutorial/files.html
        //this would be crucial when the data file > size RAM.
      }
      file.close();
      gettimeofday ( Tpend, Tzp );
      print_time ( "\n--> Time for reading points",Tpend,Tpbegin ); //seems always very small !
      gettimeofday ( Tpbegin, Tzp );
      if  ( read_points_from_file==1 )
        read_points_from_file=0;  //for instance different psi, we need to change the points.

      /// TODO should be at beginning
      Data.X=X;
      if (start==0)
      {
        
        Data.NS=NS;
        Data.BS=BS;
        Data.Pairs=Pairs;
        Data.Sec=Sec;
        Data.Bl0=Bl0;
        Data.Bl=Bl;
        Data.Bs=Bs;
        Data.Bs0=Bs0;
        Data.PairsL=PairsL;
        Data.vI_new2=vI_new2;
        Data.vI_new_old_ratio=vI_new_old_ratio;
        Data.vI_new_horner=vI_new_horner;
        Data.print_ratio=print_ratio;
        Data.ratio_refined=ratio_refined;
      }
      start++;
      /// /////////////////////////////////////
      //vI_new = initialize(Pairs, BlO); //not sure it is useful?
      cout << "\n--> Initialization of the metric: "<< endl;
      if(print_coeff==1){
      showtranspose( (Data.vI_new2) );
      }
      global_launch_method_pointwise_1a( Number_Iterations,Einstein,Number_Points,K,ERR,Psi,Refined,refined_nb_iterations,print_coeff,Data ); ///only the global constants and the structure are called
      ///this is the core of the program

      //  global_launch_method_pointwise_1(Number_Iterations,Einstein,NS,Number_Points,Pairs,Sec,BS,X,K,BlO,Bl,BsO,Bs,PairsL,ERR,vI_new2,Psi,Refined); //former procedure

      /*
      for(j=0; j<Number_Iterations; j++)
      {
        //  launch_method_pointwise_0(Number_Points,Pairs,Sec,BS,X,K,BlO,Bl,BsO,Bs,PairsL,ERR,vI_new);
        // This is for the pointwise algo
        cout << "\nResult at step " <<j+1<< " for Vi_new" <<endl;
        show(vI_new2);
        // printV(vI_new);
        printf("\n");
      }
      */
      gettimeofday ( Tpend, Tzp );
      print_time ( "--> Time for computation of balanced/refined metric :",Tpend,Tpbegin );
      MMatrix<Complex> Gnew(NS,NS);//this contains the hermitian matrice i.e our expected result
      ///MVectorToMMatrix2(Data.vI_new2,Gnew,Pairs, Bs, Bl);
       PutToFullMatrix(Data.vI_new2,Gnew,Pairs, Bs, Bl);
       //PutToFullMatrix  ( average2 (  ( Data.vI_new2 ),Bs,Bl ),Gnew,Pairs,Bs,Bl );
      //show(Gnew); getchar();



      cout<< "\n\033[34m**  Computing Weil-Petersson \033[0m \n";
      gettimeofday ( Tpbegin, Tzp );
      Data.vI_new_horner=coeffsToHorner ( Data.vI_new2 ); //stores the Horner coefficient in order to compute for instance the denominator function
      ResultsStore additResults;
      additResults.store_Results (Data.NS,K,Data.Sec,Data.Bs0,Data.Bl0,Data.Bs,Data.Pairs,Data.vI_new2 );

      ResultsWPmetric.resize(start,2);
      ResultsWPmetric[start-1][0]=Psi;
      ResultsWPmetric[start-1][1]=WPmetric(Gnew,Data,Number_Points,Psi,K,additResults,put_to_memory);
      cout << "--> WP metric for "<< Psi<<" :  \033[31m"<< real(ResultsWPmetric[start-1][1]) <<"\033[0m             \n";
      gettimeofday ( Tpend, Tzp );
      print_time ( "--> Time for computation of WP potential :",Tpend,Tpbegin );
      
      if(print_scalar==1)
      {
        cout << "\n** Press enter to print scalar curvature evaluations pointwise  \n";
        getchar();
        Global_Find_Ricci_FAST( ERR,X,Gnew,NS,K,Sec,Psi,Number_Points ); //finds the scalar curvature locally
      }
      cout <<"_____________________________________________________________________\n";
      printf("    We have done  approx. %2.2f ", (100.*start)/((double) counter));
      cout<<"%  of the whole job \n";
      cout <<"_____________________________________________________________________\n";
      write_results_WP_metric(ResultsWPmetric, precision_generate_points);  //we write the results in order that if the computation are not done till the end, at least some values are saved

    }

  }
  cout << "\n Values of Psi / associated WP potential ";
  show(ResultsWPmetric);
}






