/***************************************************************************
 *   Copyright (C) 2007 by Julien Keller   *
 *   j.keller@imperial.ac.uk   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "iPoint.h"

///creates a structure point and do basic operations related to it.
//gives a point in the projective space
/*
void toprojective(Point &P){
  int i,position=0;
  double max_element=abs(P.comp[0][0]);
  for(i=1;i<P.length();i++){
    if(abs(P.comp[i])>max_element){
      max_element=abs(P.comp[i]);
      position=i;
    }
  }
  P.scalar(1./P.comp[position]);
  P.resize2(position);
} */
/*
iPoint iread(ifstream &file)
{
  iPoint x( read<Point>(file) );
  file >> x.KP;
  for(int i=0; i<Dimension; i++) file >> x.HDKP[i];
  file >> x.g >> x.A >> x.CY4 >> x.DxDy;
  return x;
}
*/
void Eta(const VVector<double> &v)
{
  double t=0, sigma=0;
  int i, vs=v.size();
  for(i=0; i<vs; i++) t += abs(v[i]); t /= vs;
  for(i=0; i<vs; i++) sigma += pow( abs(v[i])-t, 2);
  sigma = sqrt(sigma/(vs-1));
  cout << sigma/t << ' ';
}

void EtaV(const vector<VVector<double> > &v)
{
  int i,j, Vs=v.size(), vs=v[0].size();
  VVector<double> t;
  t.resize(Vs,1);
  for(i=1; i<vs; i++)
  {
    for(j=0; j<Vs; j++) t[j] = v[j][i]/v[j][0];
    Eta(t);
  }
}

MMatrix<double> abs(const MMatrix<Complex> &G)
{
  uint k=100000, i,j;
  MMatrix<double> Gt(G.getHeight(),G.getWidth());
  for(i=0; i<G.getHeight(); i++)
    for(j=0; j<G.getWidth(); j++) Gt[i][j]= floor(k*abs(G[i][j]))/k;
  return Gt;
}
/*
VectorD abs(const Vector &v)
{
  uint k=100000, i;
  VectorD vt(v.size());
  for(i=0; i<v.size(); i++) vt(i) = floor(k*abs(v(i)))/k;
  return vt;
}
*/
/*
void errors(const vector<Matrix> &B, Matrix &Mean, MMatrix<double> &StdDev)
{
  int i, n=B.size(), r=B[0].size1();
  MMatrix<double> t(r,r);

  for(i=0; i<n; i++) Mean += B[i]; Mean /= double(n);
  for(i=0; i<n; i++) {t = abs(B[i]-Mean); StdDev += t;}
  StdDev /= ( (double) (n-1));
}
*/
VVector<double> real(const  VVector<Complex> &v)
{
  VVector<double> vt;
  vt.resize(v.size(),1);
  for(uint i=0; i<v.size(); i++) vt[i] = real(v[i]);
  return vt;
}
/*
double detHM(const MMatrix<Complex> &G)
{            // Computes the determinant of a Hermitian Matrix as a double
  Complex s;
  int n = G.size1();
  Matrix Csq(n,n), H(n,n);
  u::identity_matrix<Complex> Id(n);
  H = G;
  Csq = 1.0*Id;
  int a,b,c;
  for(a=0; a<n; a++)
  {
    for(b=0; b<a; b++)
    {
      s = 0;
      if(b>0) for(c=0; c<=b-1; c++) s += Csq(a,c)*conj(Csq(b,c));
      Csq(a,b) = (H(a,b)-s)/Csq(b,b);
    }
    s = 0;
    if(a>0) for(c=0; c<=a-1; c++) s += Csq(a,c)*conj(Csq(a,c));
    Csq(a,a) = sqrt(H(a,a)-s);
  }
  Complex detMat=1.0;
  for(a=0;a<n;a++) detMat *= Csq(a,a);
  return norm(detMat);
}
*/
/*
Matrix HermToMat(const hMatrix &H)
{
  int i,j, n=H.size1();
  Matrix t(n,n);
  Complex s;
  for(i=0; i<n; i++)
{
    t(i,i) = H(i,i);
    for(j=i+1; j<n; j++)
{s = H(i,j); t(i,j) = s; t(j,i) = conj(s);}
}
  return t;
}

hMatrix MatToHerm(const Matrix &M)
{
  int i,j, n=M.size1();
  hMatrix h(n,n);
  for(i=0; i<n; i++)
    for(j=i; j<n; j++)
      h(i,j) = M(i,j);
  return h;
}

void InvertH(const hMatrix &H, hMatrix &Hi, double ERR)
{
  Matrix t=HermToMat(H), ti;
  Invert<Complex>(t, ti, ERR);
  t = ti + herm(ti);
  ti = (1.0/2) * t;
  hAdaptor hi(ti);
  Hi = hi;
  //Hi = MatToHerm(ti);
}
*/
