/***************************************************************************
 *   Copyright (C) 2007 by Julien Keller   *
 *   j.keller@imperial.ac.uk   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "in-output.h"
#define PI  3.14159265358979323846

void write_results_WP_metric(MMatrix<Complex> &M, int precision_generate_points) //here M is a matrix N x 2 with N number of different values Psi and M[i][1] = g_\psi\psi real, for \psi = M[i][0]
//this will be used with Mathematica
{
  ofstream file("WPmetric_PSI.dat");  //this will contain the values g_\psi\bar\psi associated to \psi
  file.precision(precision_generate_points);
  for(int i=0; i<M.getHeight();i++)
  {
	file << real(M[i][0]) << "   "<< imag(M[i][0]) << "   " << real(M[i][1]) << '\n';
     //   file << abs(M[i][0])*cos((2.0*PI/5.0)-arg(M[i][0])) << "   " << abs(M[i][0])*sin((2.0*PI/5.0)-arg(M[i][0])) << "   " << real(M[i][1]) << '\n';
  }
  file.close();
}



void write_results_in_file(MMatrix<double>* p_an,int method)
{
  const MMatrix<double> & an = *p_an;
  bool possible=0;
  int numb=0;
  std::string name_file;  //name of file for output
  while(possible==0)
  {
    std::ostringstream s2;
    s2 << "res" << numb <<".txt";
    name_file=s2.str();
    ifstream file(name_file.c_str());
    if(file==NULL)
    {
      possible=1;
      ofstream file(name_file.c_str());
      cout << "\n Writing data in file " << name_file <<endl;
      file << "Metric obtained by";
      if(method==0){
        file << " Balanced method"<<endl;
      }
      if(method==1){
        file << " Ricci method"<<endl;
      }
      file<< an << endl;
      an.writeToStream(file);
      file.close();
    }
    else numb++;
  }
  
  //ofstream file(name_file.c_str(),ofstream::app);
}



void skipline(ifstream & mystream)
{
  mystream.ignore(100,'\n');
}

//prints the time between two timers in milli-seconds.
void print_time(char* a,struct timeval *Tpf,struct timeval *Tps){
  printf("%s %ld sec",a,
          (Tpf->tv_usec-Tps->tv_usec<0)?(Tpf->tv_sec-Tps->tv_sec-1):(Tpf->tv_sec-Tps->tv_sec));
  printf(" %ld msec", (Tpf->tv_usec-Tps->tv_usec<0)?(1000000+(Tpf->tv_usec-Tps->tv_usec))/1000:
          ((Tpf->tv_usec-Tps->tv_usec))/1000);
  printf("\n");
}

           
