/***************************************************************************
 *   Copyright (C) 2007 by Julien Keller   *
 *   j.keller@imperial.ac.uk   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef INOUTPUT
#define INOUTPUT

#include <stdio.h> //standard basic library
#include <stdlib.h> //standard basic library
#include <iostream> //standard library for text input and output
#include <iomanip>
#include <string>//standard library for easy to use strings
#include <sstream> //standard library to make combining strings easier
#include <fstream>


#include "MMatrix.h" //library to handle matrices in memory quickly
#include <vector>
#include <sys/time.h> //get the time to check speed


#define Complex  std::complex<double>
#define _Complex_I std::complex<double>(0, 1)

using namespace std;
//typedef vector<int>            vectorI;
typedef vector<vector<int> >  vvectorI;


//#include <boost/numeric/ublas/vector.hpp>
//#include <boost/numeric/ublas/matrix.hpp>
//#include <boost/numeric/ublas/io.hpp>
//namespace u = boost::numeric::ublas;

//typedef u::matrix<Complex>     Matrix;
//typedef u::vector<Complex>     Vector;

//typedef u::matrix<double> MatrixD;
//typedef u::vector<double> VectorD;

//typedef u::matrix<int>    MatrixI;
//typedef u::vector<int>    VectorI;

//typedef u::vector<Matrix> VectorM;
//typedef u::matrix<Matrix> MatrixM;

void write_results_WP_metric(MMatrix<Complex> &M, int precision_generate_points);
void write_results_in_file(MMatrix<double> *,int);
void skipline(ifstream &);



template<class T> void print(const T &t)
{           // print a vector<vector>
   uint i,j;
   for(i=0; i<t.size(); i++)
   {
      for(j=0; j<t[i].size(); j++) cout << t[i][j] << ','; //cout <<'\n';}
      cout << " | ";
   }
   cout<< "\n";
}

template<class T> void printM(const T &t)
{                       // print a Matrix
   for(size_t i=0; i<t.size1(); i++)
   {for(size_t j=0; j<t.size2(); j++) cout <<setprecision(3)<<setw(4) << t(i,j) << ' '; cout << "\n";}
}

template<class T> void printV(const T &t)  // print a Vector
{ for(uint i=0; i<t.size(); i++) cout << t[i] << ' '; cout << "   ";}

template<class T> void readVector(T &x, ifstream &file) {for(int i=0; i<x.size(); i++) file >> x(i);}

template<class T> void printVector(const T &x, ofstream &file) {for(int i=0; i<x.size(); i++) file << x(i) << "\n";}

template<class T> void readMatrix(T &t, ifstream &file)
{
   for(uint i=0; i<t.size1(); i++)
      for(uint j=0; j<t.size1(); j++) file >> t(i,j);
}

template<class T> void printMatrix(const T &t, ofstream &file)  // print a Matrix
{
   for(uint i=0; i<t.size1(); i++)
      for(uint j=0; j<t.size2(); j++) file << t(i,j) << "\n";
}

template<class T> void printMMaple(const T &t, ofstream &file)  // print a Matrix
{
   for(int i=0; i<t.size1(); i++)
   {for(int j=0; j<t.size2(); j++) {file << t(i,j); if(j!=t.size2()-1) file << '\t';} file << "\n";}
}

template<class T> void printMaple(const T &t, ofstream &file)  // print a vector<vector>
{
   int i,j;
   for(i=0; i<t.size(); i++)
   {for(j=0; j<t[i].size(); j++) {file << t[i][j]; if(j!=t[i].size()-1) file << '\t';} file << '\n';}
   cout << "\n";
}
/*
void initialize_timer(struct timeval &Tpbegin,struct timeval &Tpend,struct timezone &Tzp);
*/

void print_time(char *a,struct timeval *Tpf,struct timeval *Tps);

#endif
